#!/usr/bin/perl

use POSIX qw(ceil floor);

$|++;

$num_blocks = 23;

# From iperf
$bytes_in_packet = 1470-36;

while (<STDIN>)
{
	$line = $_;
	chomp($line);

	# Load the bit errors into a hash
	%packet_bit_errors = ();
	$can_recover_packet = 0;

	@s = split(/\s+/, $line);
	foreach $bit (@s)
	{
		#print "bad bit $bit\n";
		$packet_bit_errors{$bit} = 1;
	}

	# Find the block with the worst number of error bytes
	# Figure out with what number of recovery bytes that we can repair the packet
	for ($i = 1; $i <= 64; $i++)
	{
		$r = 2*$i;
		$c = 255-$r; # Block size

		$num_blocks = ceil($bytes_in_packet/$c);
		$max_error_bytes_in_block = 0;

		for ($block = 0; $block < $num_blocks; $block++)
		{
			#print "num blocks $num_blocks block size is $c\n";
			%block_byte_errors = ();
			for ($bit = $block*$c*8; $bit < ($block+1)*$c*8; $bit++)
			{
				if (defined($packet_bit_errors{$bit}))
				{
					$block_byte_errors{int($bit/8)} = 1;
				}
			}
			@error_bytes = keys(%block_byte_errors);
			if ($max_error_bytes_in_block < $#error_bytes+1)
			{
				$max_error_bytes_in_block = $#error_bytes+1;
			}
		}

		#print "Max bytes in block $max_error_bytes_in_block Repair gives you $i\n";
		if ($max_error_bytes_in_block <= $i)
		{
			print $num_blocks*$r*8,"\n";
			$can_recover_packet = 1;
			last;
		}
	}

	# Could not recover packet with FEC have to resend the entire thing
	if (!$can_recover_packet)
	{
		print $bytes_in_packet*8,"\n";
	}
}
